/************************************************************************/
/* gtctypes.h - GPL Telescope Control Library Types Header		*/
/************************************************************************/
/*
 *  (c) 2004 Todd Shadburn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/************************************************************************/

#ifndef _GTCTYPES_H_
#define _GTCTYPES_H_


/* Opaque Structures for the API */
typedef struct	_GtcModule		GtcModule;
typedef struct	_GtcScope		GtcScope;
typedef struct	_GtcObservatory		GtcObservatory;
typedef struct	_GtcOption		GtcOption;


/* BEGIN: API visible structures */
typedef struct	_GtcDate		GtcDate;
typedef struct	_GtcTime		GtcTime;
typedef struct	_GtcRa			GtcRa;
typedef struct	_GtcDec			GtcDec;
typedef struct	_GtcControlValue	GtcControlValue;
typedef struct	_GtcControl		GtcControl;


struct _GtcDate {
	int	year;
	int	month;
	int	day;
};


struct _GtcTime {
	int	hour;
	int	minute;
	int	second;
};


struct _GtcRa {
	int	hour;
	int	minute;
	int	second;
};


struct _GtcDec {
	double	deg;
};


struct _GtcOption {
	char	*name;		/* option name */
	int	type;		/* option type (INT, DOUBLE, or STRING) */
	double	minvalue;	/* option minimum value (int or double) */
	double	maxvalue;	/* option maximum value (int or double) */
	double	defvalue;	/* option default value (int, double, boolean) */
	int	flags;		/* option flags */
};


struct _GtcControlValue {
	char		*label;		/* control value label */
	double		value;		/* real control value */
};


struct _GtcControl {
	unsigned long	reserved;	/* reserved for future use */
	double		minvalue;	/* minimum value */
	double		maxvalue;	/* maximum value */
	double		defvalue;	/* default value */
	GtcControlValue	*valuearray;	/* array of labels/values */
};
/* END: API visible structures */


#endif


